package com.yushu.system.service;

import java.util.List;
import org.springframework.web.multipart.MultipartFile;
import com.yushu.system.domain.SysFileInfo;

/**
 * 文件Service接口
 * 
 * @author yushu
 * @date 2024-11-15
 */
public interface ISysFileService 
{
    /**
     * 查询文件
     * 
     * @param fileId 文件主键
     * @return 文件
     */
    public SysFileInfo selectSysFileByFileId(Long fileId);

    /**
     * 查询文件列表
     * 
     * @param sysFile 文件
     * @return 文件集合
     */
    public List<SysFileInfo> selectSysFileList(SysFileInfo sysFile);

    /**
     * 上传文件
     * 
     * @param file 文件
     * @param folderId 文件夹ID
     * @param fileName 自定义文件名
     * @return 结果
     */
    public SysFileInfo uploadFile(MultipartFile file, Long folderId, String fileName) throws Exception;

    /**
     * 修改文件
     * 
     * @param sysFile 文件
     * @return 结果
     */
    public int updateSysFile(SysFileInfo sysFile);

    /**
     * 批量删除文件
     * 
     * @param fileIds 需要删除的文件主键集合
     * @return 结果
     */
    public int deleteSysFileByFileIds(Long[] fileIds);

    /**
     * 删除文件信息
     * 
     * @param fileId 文件主键
     * @return 结果
     */
    public int deleteSysFileByFileId(Long fileId);
    
    /**
     * 下载文件
     * 
     * @param fileId 文件ID
     * @return 文件对象
     */
    public SysFileInfo downloadFile(Long fileId);
    
    /**
     * 移动文件
     * 
     * @param fileId 文件ID
     * @param targetFolderId 目标文件夹ID
     * @return 结果
     */
    public int moveFile(Long fileId, Long targetFolderId);
    
    /**
     * 复制文件
     * 
     * @param fileId 文件ID
     * @param targetFolderId 目标文件夹ID
     * @return 结果
     */
    public int copyFile(Long fileId, Long targetFolderId);
}
